<?php
DEFINE("PIE_VALUE_ABS",1);
DEFINE("PIE_VALUE_PER",0);
DEFINE("PIE_VALUE_PERCENTAGE",0);
class PiePlot {
	var $posx=0.5,$posy=0.5;
	var $radius=0.3;
	var $explode_radius=array(),$explode_all=false,$explode_r=20;
	var $labels=null, $legends=null;
	var $csimtargets=null;  
	var $csimareas='';		
	var $csimalts=null;		
	var $data=null;
	var $title;
	var $startangle=0;
	var $weight=1, $color="black";
	var $legend_margin=6,$show_labels=true;
	var $themearr = array(
	"earth" 	=> array(136,34,40,45,46,62,63,134,74,10,120,136,141,168,180,77,209,218,346,395,89,430),
	"pastel" => array(27,415,128,59,66,79,105,110,42,147,152,230,236,240,331,337,405,38),
	"water"  => array(8,370,24,40,335,56,213,237,268,14,326,387,10,388),
	"sand"   => array(27,168,34,170,19,50,65,72,131,209,46,393));
	var $theme="earth";
	var $setslicecolors=array();
	var $labeltype=0; 
	var $pie_border=true,$pie_interior_border=true;
	var $value;
	var $ishadowcolor='',$ishadowdrop=4;
	var $ilabelposadj=1;
	var $legendcsimtargets = array();
	var $legendcsimalts = array();
	function PiePlot($data) {
	$this->data = array_reverse($data);
	$this->title = new Text("");
	$this->title->SetFont(FF_FONT1,FS_BOLD);
	$this->value = new DisplayValue();
	$this->value->Show();
	$this->value->SetFormat('%.1f%%');
	}
	function SetCenter($x,$y=0.5) {
	$this->posx = $x;
	$this->posy = $y;
	}
	function SetColor($aColor) {
	$this->color = $aColor;
	}
	function SetShadow($aColor='darkgray',$aDropWidth=4) {
	$this->ishadowcolor = $aColor;
	$this->ishadowdrop = $aDropWidth;
	}
	function SetCSIMTargets($targets,$alts=null) {
	$this->csimtargets=array_reverse($targets);
	if( is_array($alts) )
		$this->csimalts=array_reverse($alts);
	}
	function GetCSIMareas() {
	return $this->csimareas;
	}
	function AddSliceToCSIM($i,$xc,$yc,$radius,$sa,$ea) {  
	    
	while( $sa > 2*M_PI ) $sa = $sa - 2*M_PI;
	while( $ea > 2*M_PI ) $ea = $ea - 2*M_PI;
	$sa = 2*M_PI - $sa;
	$ea = 2*M_PI - $ea;
	
	$coords = "$xc, $yc";
	
	$xp = floor(($radius*cos($ea))+$xc);
	$yp = floor($yc-$radius*sin($ea));
	$coords.= ", $xp, $yp";
	
	$a=$ea+0.2;
	while ($a<$sa) {
		$xp = floor($radius*cos($a)+$xc);
		$yp = floor($yc-$radius*sin($a));
		$coords.= ", $xp, $yp";
		$a += 0.2;
	}
		
	
	$xp = floor($radius*cos($sa)+$xc);
	$yp = floor($yc-$radius*sin($sa));
	$coords.= ", $xp, $yp";
	if( !empty($this->csimtargets[$i]) )
		$this->csimareas .= "<area shape=\"poly\" coords=\"$coords\" href=\"".
		$this->csimtargets[$i]."\"";
	if( !empty($this->csimalts[$i]) ) {
		$tmp=sprintf($this->csimalts[$i],$this->data[$i]);
		$this->csimareas .= " alt=\"$tmp\" title=\"$tmp\"";
	}
	$this->csimareas .= ">\n";
	}
	function SetTheme($aTheme) {
	if( in_array($aTheme,array_keys($this->themearr)) )
		$this->theme = $aTheme;
	else
		JpGraphError::Raise("PiePLot::SetTheme() Unknown theme: $aTheme");
	}
	function ExplodeSlice($e,$radius=20) {
	$this->explode_radius[$e]=$radius;
	}
	function ExplodeAll($radius=20) {
	$this->explode_all=true;
	$this->explode_r = $radius;
	}
	function Explode($aExplodeArr) {
	if( !is_array($aExplodeArr) ) {
		JpGraphError::Raise("Argument to PiePlot::Explode() must be an array.");
	}
	$this->explode_radius = $aExplodeArr;
	}
	function SetSliceColors($aColors) {
	$this->setslicecolors = array_reverse($aColors);
	}
	function SetStartAngle($aStart) {
	if( $aStart < 0 || $aStart > 360 ) {
		JpGraphError::Raise('Slice start angle must be between 0 and 360 degrees.');
	}
	$this->startangle = 360-$aStart;
	}
	function SetFont($family,$style=FS_NORMAL,$size=10) {
		JpGraphError::Raise('PiePlot::SetFont() is deprecated. Use PiePlot->value->SetFont() instead.');
	}
	
	function SetSize($aSize) {
	if( ($aSize>0 && $aSize<=0.5) || ($aSize>10 && $aSize<1000) )
		$this->radius = $aSize;
	else
		JpGraphError::Raise("PiePlot::SetSize() Radius for pie must either be specified as a fraction
	                            [0, 0.5] of the size of the image or as an absolute size in pixels 
	                            in the range [10, 1000]");
	}
	function SetFontColor($aColor) {
	JpGraphError::Raise('PiePlot::SetFontColor() is deprecated. Use PiePlot->value->SetColor() instead.');
	}
	
	function SetLegends($aLegend) {
	$this->legends = $aLegend;
	}
	
	function SetLabels($aLabels,$aLblPosAdj="auto") {
	$this->labels = array_reverse($aLabels);
	$this->ilabelposadj=$aLblPosAdj;
	}
	function SetLabelPos($aLblPosAdj) {
	$this->ilabelposadj=$aLblPosAdj;
	}
	
	function SetLabelType($t) {
	if( $t<0 || $t>1 ) 
		JpGraphError::Raise("PiePlot::SetLabelType() Type for pie plots must be 0 or 1 (not $t).");
	$this->labeltype=$t;
	}
	function SetValueType($aType) {
	$this->SetLabelType($aType);
	}
	
	function ShowBorder($exterior=true,$interior=true) {
	$this->pie_border = $exterior;
	$this->pie_interior_border = $interior;
	}
	
	function Legend(&$graph) {
	$colors = array_keys($graph->img->rgb->rgb_table);
   	sort($colors);	
   	$ta=$this->themearr[$this->theme];	
   	
   	if( $this->setslicecolors==null ) 
		$numcolors=count($ta);
   	else
		$numcolors=count($this->setslicecolors);
		
	$sum=0;
	for($i=0; $i<count($this->data); ++$i)
		$sum += $this->data[$i];
	
	if( $sum==0 )
		JpGraphError::Raise("Illegal pie plot. Sum of all data is zero for Pie!");
	
	
	$n = min(count($this->legends),count($this->data));
	if( $this->legends != "" )
		$this->legends = array_reverse($this->legends);
	for( $i=$n-1; $i >= 0; --$i ) {
		$l = $this->legends[$i];
		
		if( $this->labeltype==0 ) {
		$l = sprintf($l,100*$this->data[$i]/$sum);
		}
		else {
		$l = sprintf($l,$this->data[$i]);
		}
		
		$alt = sprintf($this->csimalts[$i],$this->data[$i]);
				
		if( $this->setslicecolors==null ) 
		$graph->legend->Add($l,$colors[$ta[$i%$numcolors]],"",0,
					$this->csimtargets[$i],$alt);
		else
		$graph->legend->Add($l,$this->setslicecolors[$i%$numcolors],"",0,
					$this->csimtargets[$i],$alt);
	}
	}
	function Stroke(&$img,$aaoption=0) {
	
	
	
	
	
	
	$expscale = $aaoption === 1 ? 2 : 1;
	$colors = array_keys($img->rgb->rgb_table);
   	sort($colors);	
   	$ta=$this->themearr[$this->theme];	
   	
   	if( $this->setslicecolors==null ) 
		$numcolors=count($ta);
   	else
		$numcolors=count($this->setslicecolors);
   	
	
	$sum=0;
	$n = count($this->data);
	for($i=0; $i < $n; ++$i)
		$sum += $this->data[$i];
	
	if( $sum==0 )
		JpGraphError::Raise("Sum of all data is 0 for Pie.");
	
	if( $this->radius <= 1 )
		$radius = floor($this->radius*min($img->width,$img->height));
	else {
		$radius = $aaoption === 1 ? $this->radius*2 : $this->radius;
	}
	if( $this->posx <= 1 && $this->posx > 0 )
		$xc = round($this->posx*$img->width);
	else
		$xc = $this->posx ;
	if( $this->posy <= 1 && $this->posy > 0 )
		$yc = round($this->posy*$img->height);
	else
		$yc = $this->posy ;
		
	$this->startangle = $this->startangle*M_PI/180;
	$n = count($this->data);
	if( $this->explode_all )
		for($i=0; $i < $n; ++$i)
		$this->explode_radius[$i]=$this->explode_r;;
	if( $this->ishadowcolor != "" && $aaoption !== 2) {
		$accsum=0;
		$angle2 = $this->startangle;
		$img->SetColor($this->ishadowcolor);
		for($i=0; $sum>0 && $i < $n; ++$i) {
		$d = $this->data[$i];
		$angle1 = $angle2;
		$accsum += $d;
		$angle2 = $this->startangle+2*M_PI*$accsum/$sum;
		if( empty($this->explode_radius[$i]) )
			$this->explode_radius[$i]=0;
		$la = 2*M_PI - (abs($angle2-$angle1)/2.0+$angle1);
		$xcm = $xc + $this->explode_radius[$i]*cos($la)*$expscale;
		$ycm = $yc - $this->explode_radius[$i]*sin($la)*$expscale;
		
		$xcm += $this->ishadowdrop*$expscale;
		$ycm += $this->ishadowdrop*$expscale;
		$img->CakeSlice($xcm,$ycm,$radius,$radius,
				$angle1*180/M_PI,$angle2*180/M_PI,$this->ishadowcolor);
		
		}
	}
	$accsum=0;
	$angle2 = $this->startangle;
	$img->SetColor($this->color);
	for($i=0; $sum>0 && $i < $n; ++$i) {
		$d = $this->data[$i];
		$angle1 = $angle2;
		$accsum += $d;
		$angle2 = $this->startangle+2*M_PI*$accsum/$sum;
		if( $this->setslicecolors==null )
		$slicecolor=$colors[$ta[$i%$numcolors]];
		else
		$slicecolor=$this->setslicecolors[$i%$numcolors];
		if( $this->pie_interior_border && $aaoption===0 )
		$img->SetColor($this->color);
		else
		$img->SetColor($slicecolor);
		$arccolor = $this->pie_border && $aaoption===0 ? $this->color : "";
		$this->la[$i] = 2*M_PI - (abs($angle2-$angle1)/2.0+$angle1);
		if( empty($this->explode_radius[$i]) )
		$this->explode_radius[$i]=0;
		$xcm = $xc + $this->explode_radius[$i]*cos($this->la[$i])*$expscale;
		$ycm = $yc - $this->explode_radius[$i]*sin($this->la[$i])*$expscale;
		if( $aaoption !== 2 ) {
		$img->CakeSlice($xcm,$ycm,$radius-1,$radius-1,
				$angle1*180/M_PI,$angle2*180/M_PI,$slicecolor,$arccolor);
		}
		if ($this->csimtargets && $aaoption !== 1 ) 
		$this->AddSliceToCSIM($i,$xcm,$ycm,$radius,$angle1,$angle2);
	}
	if( $this->value->show && $aaoption !== 1 ) {
		
		for( $i=0; $i < $n; ++$i) {
		if( $this->labeltype==0 )
			if( $sum != 0 )
			$l = 100.0*$this->data[$i]/$sum;
			else
			$l = 0.0;
		else
			$l = $this->data[$i]*1.0;
		if( isset($this->labels[$i]) && is_string($this->labels[$i]) )
			$this->labels[$i]=sprintf($this->labels[$i],$l);
		else
			$this->labels[$i]=$l;
		}
		$this->StrokeAllLabels($img,$xc,$yc,$radius);
	}
	
	if( $aaoption !== 1 ) {
		$this->title->Pos($xc,
			  $yc-$this->title->GetFontHeight($img)-$radius-$this->title->margin,
			  "center","bottom");
		$this->title->Stroke($img);
	}
		
	}
	function StrokeAllLabels($img,$xc,$yc,$radius) {
	$n = count($this->labels);
	for($i=0; $i < $n; ++$i) {
		$this->StrokeLabel($this->labels[$i],$img,$xc,$yc,$this->la[$i],
				   $radius + $this->explode_radius[$i]); 
	}
	}
	
	function StrokeLabel($label,$img,$xc,$yc,$a,$r) {
	
	if( $this->ilabelposadj === 'auto' )
		$this->ilabelposadj = 0.65;
	
	
	if( $this->ilabelposadj < 1.0 ) {
		$this->value->SetAlign('center','center');
		$this->value->margin = 0;
		
		$xt=round($this->ilabelposadj*$r*cos($a)+$xc);
		$yt=round($yc-$this->ilabelposadj*$r*sin($a));
		
		$this->value->Stroke($img,$label,$xt,$yt);
	}
	else {
		$this->value->halign = "left";
		$this->value->valign = "top";
		$this->value->margin = 0;
		
		
		
		
		
		
		
		$img->SetFont($this->value->ff,$this->value->fs,$this->value->fsize);
		$h=$img->GetTextHeight($label);
		
		
		if( is_numeric($label) ) {
		if( $label > 0 )
			$w=$img->GetTextWidth(sprintf($this->value->format,$label));
		else
			$w=$img->GetTextWidth(sprintf($this->value->negformat,$label));
		}
		else
		$w=$img->GetTextWidth($label);
		if( $this->ilabelposadj > 1.0 && $this->ilabelposadj < 5.0) {
		$r *= $this->ilabelposadj;
		}
		$r += $img->GetFontHeight()/1.5;
		$xt=round($r*cos($a)+$xc);
		$yt=round($yc-$r*sin($a));
		while( $a > 2*M_PI ) $a -= 2*M_PI;
		if( $a>=7*M_PI/4 || $a <= M_PI/4 ) $dx=0;
		if( $a>=M_PI/4 && $a <= 3*M_PI/4 ) $dx=($a-M_PI/4)*2/M_PI; 
		if( $a>=3*M_PI/4 && $a <= 5*M_PI/4 ) $dx=1;
		if( $a>=5*M_PI/4 && $a <= 7*M_PI/4 ) $dx=(1-($a-M_PI*5/4)*2/M_PI);
		
		if( $a>=7*M_PI/4 ) $dy=(($a-M_PI)-3*M_PI/4)*2/M_PI;
		if( $a<=M_PI/4 ) $dy=(1-$a*2/M_PI);
		if( $a>=M_PI/4 && $a <= 3*M_PI/4 ) $dy=1;
		if( $a>=3*M_PI/4 && $a <= 5*M_PI/4 ) $dy=(1-($a-3*M_PI/4)*2/M_PI);
		if( $a>=5*M_PI/4 && $a <= 7*M_PI/4 ) $dy=0;
		$this->value->Stroke($img,$label,$xt-$dx*$w,$yt-$dy*$h);
	}
	}	
} 
class PiePlotC extends PiePlot {
	var $imidsize=0.5;		
	var $imidcolor='white';
	var $midtitle='';
	var $middlecsimtarget="",$middlecsimalt="";
	function PiePlotC($data,$aCenterTitle='') {
	parent::PiePlot($data);
	$this->midtitle = new Text();
	$this->midtitle->ParagraphAlign('center');
	}
	function SetMid($aTitle,$aColor='white',$aSize=0.5) {
	$this->midtitle->Set($aTitle);
	$this->imidsize = $aSize ; 
	$this->imidcolor = $aColor ; 
	}
	function SetMidTitle($aTitle) {
	$this->midtitle->Set($aTitle);
	}
	function SetMidSize($aSize) {
	$this->imidsize = $aSize ; 
	}
	function SetMidColor($aColor) {
	$this->imidcolor = $aColor ; 
	}
	function SetMidCSIM($aTarget,$aAlt) {
	$this->middlecsimtarget = $aTarget;
	$this->middlecsimalt = $aAlt;
	}
	function AddSliceToCSIM($i,$xc,$yc,$radius,$sa,$ea) {  
	    
	while( $sa > 2*M_PI ) $sa = $sa - 2*M_PI;
	while( $ea > 2*M_PI ) $ea = $ea - 2*M_PI;
	$sa = 2*M_PI - $sa;
	$ea = 2*M_PI - $ea;
	
	$xp = floor(($this->imidsize*$radius*cos($ea))+$xc);
	$yp = floor($yc-($this->imidsize*$radius*sin($ea)));
	$coords = "$xp, $yp";
	
	$a=$ea+0.25;
	while ($a < $sa) {
		$xp = floor(($this->imidsize*$radius*cos($a)+$xc));
		$yp = floor($yc-($this->imidsize*$radius*sin($a)));
		$coords.= ", $xp, $yp";
		$a += 0.25;
	}
	
	$xp = floor(($this->imidsize*$radius*cos($sa)+$xc));
	$yp = floor($yc-($this->imidsize*$radius*sin($sa)));
	$coords.= ", $xp, $yp";
	
	$xp = floor($radius*cos($sa)+$xc);
	$yp = floor($yc-$radius*sin($sa));
	$coords.= ", $xp, $yp";	
	
	$a=$sa - 0.25;
	while ($a > $ea) {
		$xp = floor($radius*cos($a)+$xc);
		$yp = floor($yc-$radius*sin($a));
		$coords.= ", $xp, $yp";
		$a -= 0.25;
	}
		
	
	$xp = floor($radius*cos($ea)+$xc);
	$yp = floor($yc-$radius*sin($ea));
	$coords.= ", $xp, $yp";
	
	$xp = floor(($this->imidsize*$radius*cos($ea))+$xc);
	$yp = floor($yc-($this->imidsize*$radius*sin($ea)));
	$coords .= ", $xp, $yp";
	if( !empty($this->csimtargets[$i]) )
		$this->csimareas .= "<area shape=\"poly\" coords=\"$coords\" href=\"".
		$this->csimtargets[$i]."\"";
	if( !empty($this->csimalts[$i]) ) {
		$tmp=sprintf($this->csimalts[$i],$this->data[$i]);
		$this->csimareas .= " alt=\"$tmp\" title=\"$tmp\"";
	}
	$this->csimareas .= ">\n";
	}
	function Stroke($img,$aaoption=0) {
	
	$tmp =  $this->value->show;
	$this->value->show = false;
	parent::Stroke($img,$aaoption);
	$this->value->show = $tmp;
 	$xc = round($this->posx*$img->width);
	$yc = round($this->posy*$img->height);
	$radius = floor($this->radius * min($img->width,$img->height)) ;
	if( $this->imidsize > 0 && $aaoption !== 2 ) {
		if( $this->ishadowcolor != "" ) {
		$img->SetColor($this->ishadowcolor);
		$img->FilledCircle($xc+$this->ishadowdrop,$yc+$this->ishadowdrop,
				   round($radius*$this->imidsize));
		}
		$img->SetColor($this->imidcolor);
		$img->FilledCircle($xc,$yc,round($radius*$this->imidsize));
		if(  $this->pie_border && $aaoption === 0 ) {
		$img->SetColor($this->color);
		$img->Circle($xc,$yc,round($radius*$this->imidsize));
		}
		if( !empty($this->middlecsimtarget) )
		$this->AddMiddleCSIM($xc,$yc,round($radius*$this->imidsize));
	}
	if( $this->value->show && $aaoption !== 1) {
		$this->StrokeAllLabels($img,$xc,$yc,$radius);
		$this->midtitle->Pos($xc,$yc,'center','center');
		$this->midtitle->Stroke($img);
	}
	}
	function AddMiddleCSIM($xc,$yc,$r) {
	$this->csimareas .= "<area shape=\"circle\" coords=\"$xc,$yc,$r\" href=\"".
		$this->middlecsimtarget."\"";
	if( !empty($this->middlecsimalt) ) {
		$tmp = $this->middlecsimalt;
		$this->csimareas .= " alt=\"$tmp\" title=\"$tmp\"";
	}
	$this->csimareas .= ">\n";
	}
	function StrokeLabel($label,$img,$xc,$yc,$a,$r) {
	if( $this->ilabelposadj === 'auto' )
		$this->ilabelposadj = (1-$this->imidsize)/2+$this->imidsize;
	parent::StrokeLabel($label,$img,$xc,$yc,$a,$r);
	}
}
class PieGraph extends Graph {
	var $posx, $posy, $radius;		
	var $legends=array();	
	var $plots=array();
	var $pieaa = false ;
	function PieGraph($width=300,$height=200,$cachedName="",$timeout=0,$inline=1) {
	$this->Graph($width,$height,$cachedName,$timeout,$inline);
	$this->posx=$width/2;
	$this->posy=$height/2;
	$this->SetColor(array(255,255,255));		
	}
	function Add($aObj) {
	if( is_array($aObj) && count($aObj) > 0 )
		$cl = get_class($aObj[0]);
	else
		$cl = get_class($aObj);
	if( $cl == 'text' ) 
		$this->AddText($aObj);
	else
		$this->plots[] = $aObj;
	}
	function SetAntiAliasing($aFlg=true) {
	$this->pieaa = $aFlg;
	}
	function SetColor($c) {
	$this->SetMarginColor($c);
	}
	function DisplayCSIMAreas() {
		$csim="";
		foreach($this->plots as $p ) {
		$csim .= $p->GetCSIMareas();
		}
		
		if (preg_match_all("/area shape=\"(\w+)\" coords=\"([0-9\, ]+)\"/", $csim, $coords)) {
		$this->img->SetColor($this->csimcolor);
		for ($i=0; $i<count($coords[0]); $i++) {
			if ($coords[1][$i]=="poly") {
			preg_match_all('/\s*([0-9]+)\s*,\s*([0-9]+)\s*,*/',$coords[2][$i],$pts);
			$this->img->SetStartPoint($pts[1][count($pts[0])-1],$pts[2][count($pts[0])-1]);
			for ($j=0; $j<count($pts[0]); $j++) {
				$this->img->LineTo($pts[1][$j],$pts[2][$j]);
			}
			} else if ($coords[1][$i]=="rect") {
			$pts = preg_split('/,/', $coords[2][$i]);
			$this->img->SetStartPoint($pts[0],$pts[1]);
			$this->img->LineTo($pts[2],$pts[1]);
			$this->img->LineTo($pts[2],$pts[3]);
			$this->img->LineTo($pts[0],$pts[3]);
			$this->img->LineTo($pts[0],$pts[1]);
						
			}
		}
		}
	}
	
	function Stroke($aStrokeFileName="") {
	
	
	
	
	
	
	
	$_csim = ($aStrokeFileName===_CSIM_SPECIALFILE);
	
	
	
	
	$this->iHasStroked = true;
		
		
	$n = count($this->plots);
	if( $this->pieaa ) {
		if( !$_csim ) {
		if( $this->background_image != "" ) {
			$this->StrokeFrameBackground();		
		}
		else {
			$this->StrokeFrame();		
		}
		}
		$w = $this->img->width;
		$h = $this->img->height;
		$oldimg = $this->img->img;
		$this->img->CreateImgCanvas(2*$w,2*$h);
		
		$this->img->SetColor( $this->margin_color );
		$this->img->FilledRectangle(0,0,2*$w-1,2*$h-1);
		for($i=0; $i < $n; ++$i) {
		if( $this->plots[$i]->posx > 1 ) 
			$this->plots[$i]->posx *= 2 ;
		if( $this->plots[$i]->posy > 1 ) 
			$this->plots[$i]->posy *= 2 ;
		$this->plots[$i]->Stroke($this->img,1);
		if( $this->plots[$i]->posx > 1 ) 
			$this->plots[$i]->posx /= 2 ;
		if( $this->plots[$i]->posy > 1 ) 
			$this->plots[$i]->posy /= 2 ;
		}
		$indent = $this->doframe ? ($this->frame_weight + ($this->doshadow ? $this->shadow_width : 0 )) : 0 ;
		$indent += $this->framebevel ? $this->framebeveldepth + 1 : 0 ;
		$this->img->CopyCanvasH($oldimg,$this->img->img,$indent,$indent,$indent,$indent,
					$w-2*$indent,$h-2*$indent,2*($w-$indent),2*($h-$indent));
		$this->img->img = $oldimg ;
		$this->img->width = $w ;
		$this->img->height = $h ;
		for($i=0; $i < $n; ++$i) {
		$this->plots[$i]->Stroke($this->img,2);
		$this->plots[$i]->Legend($this);
		}
	}
	else {
		if( !$_csim ) {
		if( $this->background_image != "" ) {
			$this->StrokeFrameBackground();		
		}
		else {
			$this->StrokeFrame();		
		}
		}
		
		for($i=0; $i < $n; ++$i) {
		$this->plots[$i]->Stroke($this->img);
		$this->plots[$i]->Legend($this);
		}
	}
	$this->legend->Stroke($this->img);
	$this->footer->Stroke($this->img);
	if( !$_csim ) {	
		$this->StrokeTitles();
		
		if( $this->texts != null ) {
		$n = count($this->texts);
		for($i=0; $i < $n; ++$i ) {
			$this->texts[$i]->Stroke($this->img);
		}
		}
		if( JPG_DEBUG ) {
		$this->DisplayCSIMAreas();
		}
		
		
		
		if( $aStrokeFileName == _IMG_HANDLER ) {
		return $this->img->img;
		}
		else {
		
		$this->cache->PutAndStream($this->img,$this->cache_name,$this->inline,
					   $aStrokeFileName);		
		}
	}
	}
} 
class PiePlot3D extends PiePlot {
	var $labelhintcolor="red",$showlabelhint=true,$labelmargin=0.30;
	var $angle=50;	
	var $edgecolor="", $edgeweight=1;
	var $iThickness=false;
	function PiePlot3d(&$data) {
	$this->radius = 0.5;
	$this->data = $data;
	$this->title = new Text("");
	$this->title->SetFont(FF_FONT1,FS_BOLD);
	$this->value = new DisplayValue();
	$this->value->Show();
	$this->value->SetFormat('%.0f%%');
	}
	function SetLegends($aLegend) {
	$this->legends = array_reverse($aLegend);
	}
	function SetSliceColors($aColors) {
	$this->setslicecolors = $aColors;
	}
	function Legend(&$aGraph) {
	parent::Legend($aGraph);
	$aGraph->legend->txtcol = array_reverse($aGraph->legend->txtcol);
	}
	function SetCSIMTargets($targets,$alts=null) {
	$this->csimtargets = $targets;
	$this->csimalts = $alts;
	}
	function SetEdge($aColor,$aWeight=1) {
	$this->edgecolor = $aColor;
	$this->edgeweight = $aWeight;
	}
	function SetAngle($a) {
	if( $a<5 || $a>90 )
		JpGraphError::Raise("PiePlot3D::SetAngle() 3D Pie projection angle must be between 5 and 85 degrees.");
	else
		$this->angle = $a;
	}
	function AddSliceToCSIM($i,$xc,$yc,$height,$width,$thick,$sa,$ea) {  
	$sa *= M_PI/180;
	$ea *= M_PI/180;
	$coords = "$xc, $yc";
	$xp = floor($width*cos($sa)/2+$xc);
	$yp = floor($yc-$height*sin($sa)/2);
	$coords.= ", $xp, $yp";
	if ($sa >= M_PI && $sa <= 2*M_PI*1.01) {
		$yp = floor($yp+$thick);
		$coords.= ", $xp, $yp";
	}
		
	$a=$sa+0.2;
	while ($a<$ea) {
		$xp = floor($width*cos($a)/2+$xc);
		if ($a >= M_PI && $a <= 2*M_PI*1.01) {
		$yp = floor($yc-($height*sin($a)/2)+$thick);
		} else {
		$yp = floor($yc-$height*sin($a)/2);
		}
		$coords.= ", $xp, $yp";
		$a += 0.2;
	}
		
	$xp = floor($width*cos($ea)/2+$xc);
	$yp = floor($yc-$height*sin($ea)/2);
	if ($ea >= M_PI && $ea <= 2*M_PI*1.01) {
		$coords.= ", $xp, ".floor($yp+$thick);
	}
	$coords.= ", $xp, $yp";
	$alt='';
	if( !empty($this->csimalts[$i]) ) {										
		$tmp=sprintf($this->csimalts[$i],$this->data[$i]);
		$alt="alt=\"$tmp\" title=\"$tmp\"";
	}
	if( !empty($this->csimtargets[$i]) )
		$this->csimareas .= "<area shape=\"poly\" coords=\"$coords\" href=\"".$this->csimtargets[$i]."\" $alt>\n";
	}
	function SetLabels($aLabels,$aLblPosAdj="auto") {
	$this->labels = $aLabels;
	$this->ilabelposadj=$aLblPosAdj;
	}
	function SetLabelMargin($m) {
	assert($m>0 && $m<1);
	$this->labelmargin=$m;
	}
	function ShowLabelHint($f=true) {
	$this->showlabelhint=$f;
	}
	function SetLabelHintColor($c) {
	$this->labelhintcolor=$c;
	}
	function SetHeight($aHeight) {
	  $this->iThickness = $aHeight;
	}
	function NormAngle($a) {
	if( $a > 0 ) {
		while($a > 360) $a -= 360;
	}
	else {
		while($a < 0) $a += 360;
	}
	if( $a < 0 )
		$a = 360 + $a;
	if( $a == 360 ) $a=0;
	return $a;
	}
	function Pie3DSlice($img,$xc,$yc,$w,$h,$sa,$ea,$z,$fillcolor,$shadow=0.65) {
	if( ($sa < 90 && $ea > 90) || ( ($sa > 90 && $sa < 270) && $ea > 270) ) {
		JpGraphError::Raise('Internal assertion failed. Pie3D::Pie3DSlice');
		exit(1);
	}
	$p[] = array();
	$rsa = $sa/180*M_PI;	
	$rea = $ea/180*M_PI;	
	$sinsa = sin($rsa);
	$cossa = cos($rsa);
	$sinea = sin($rea);
	$cosea = cos($rea);
	$step = 0.05;
	if( $sa >= 270 ) {
		if( $ea > 360 || ($ea > 0 && $ea <= 90) ) {
		if( $ea > 0 && $ea <= 90 ) {
			
			$rea += 2*M_PI;
		}
		$p = array($xc,$yc,$xc,$yc+$z,
			   $xc+$w*$cossa,$z+$yc-$h*$sinsa);
		$pt = array($xc,$yc,$xc+$w*$cossa,$yc-$h*$sinsa);
		for( $a=$rsa; $a < 2*M_PI; $a += $step ) {
			$tca = cos($a);
			$tsa = sin($a);
			$p[] = $xc+$w*$tca;
			$p[] = $z+$yc-$h*$tsa;
			$pt[] = $xc+$w*$tca;
			$pt[] = $yc-$h*$tsa;
		}
		$pt[] = $xc+$w;
		$pt[] = $yc;
		$p[] = $xc+$w;
		$p[] = $z+$yc;
		$p[] = $xc+$w;
		$p[] = $yc;
		$p[] = $xc;
		$p[] = $yc;
		for( $a=2*M_PI+$step; $a < $rea; $a += $step ) {
			$pt[] = $xc + $w*cos($a);
			$pt[] = $yc - $h*sin($a);
		}
			
		$pt[] = $xc+$w*$cosea;
		$pt[] = $yc-$h*$sinea;
		$pt[] = $xc;
		$pt[] = $yc;
		}
		else {
		$p = array($xc,$yc,$xc,$yc+$z,
			   $xc+$w*$cossa,$z+$yc-$h*$sinsa);
		$pt = array($xc,$yc,$xc+$w*$cossa,$yc-$h*$sinsa);
			
		$rea = $rea == 0.0 ? 2*M_PI : $rea;
		for( $a=$rsa; $a < $rea; $a += $step ) {
			$tca = cos($a);
			$tsa = sin($a);
			$p[] = $xc+$w*$tca;
			$p[] = $z+$yc-$h*$tsa;
			$pt[] = $xc+$w*$tca;
			$pt[] = $yc-$h*$tsa;
		}
		$pt[] = $xc+$w*$cosea;
		$pt[] = $yc-$h*$sinea;
		$pt[] = $xc;
		$pt[] = $yc;
			
		$p[] = $xc+$w*$cosea;
		$p[] = $z+$yc-$h*$sinea;
		$p[] = $xc+$w*$cosea;
		$p[] = $yc-$h*$sinea;
		$p[] = $xc;
		$p[] = $yc;
		}
	}
	elseif( $sa >= 180 ) {
		$p = array($xc,$yc,$xc,$yc+$z,$xc+$w*$cosea,$z+$yc-$h*$sinea);
		$pt = array($xc,$yc,$xc+$w*$cosea,$yc-$h*$sinea);
		
		for( $a=$rea; $a>$rsa; $a -= $step ) {
		$tca = cos($a);
		$tsa = sin($a);
		$p[] = $xc+$w*$tca;
		$p[] = $z+$yc-$h*$tsa;
		$pt[] = $xc+$w*$tca;
		$pt[] = $yc-$h*$tsa;
		}
		$pt[] = $xc+$w*$cossa;
		$pt[] = $yc-$h*$sinsa;
		$pt[] = $xc;
		$pt[] = $yc;
		
		$p[] = $xc+$w*$cossa;
		$p[] = $z+$yc-$h*$sinsa;
		$p[] = $xc+$w*$cossa;
		$p[] = $yc-$h*$sinsa;
		$p[] = $xc;
		$p[] = $yc;
	}
	elseif( $sa >= 90 ) {
		if( $ea > 180 ) {
		$p = array($xc,$yc,$xc,$yc+$z,$xc+$w*$cosea,$z+$yc-$h*$sinea);
		$pt = array($xc,$yc,$xc+$w*$cosea,$yc-$h*$sinea);
		for( $a=$rea; $a > M_PI; $a -= $step ) {
			$tca = cos($a);
			$tsa = sin($a);		    
			$p[] = $xc+$w*$tca;
			$p[] = $z + $yc - $h*$tsa;
			$pt[] = $xc+$w*$tca;
			$pt[] = $yc-$h*$tsa;
		}
		$p[] = $xc-$w;
		$p[] = $z+$yc;
		$p[] = $xc-$w;
		$p[] = $yc;
		$p[] = $xc;
		$p[] = $yc;
		$pt[] = $xc-$w;
		$pt[] = $z+$yc;
		$pt[] = $xc-$w;
		$pt[] = $yc;
		for( $a=M_PI-$step; $a > $rsa; $a -= $step ) {
			$pt[] = $xc + $w*cos($a);
			$pt[] = $yc - $h*sin($a);
		}
		$pt[] = $xc+$w*$cossa;
		$pt[] = $yc-$h*$sinsa;
		$pt[] = $xc;
		$pt[] = $yc;
		}
		else { 
		$p = array($xc,$yc,$xc,$yc+$z,
			   $xc+$w*$cosea,$z+$yc-$h*$sinea,
			   $xc+$w*$cosea,$yc-$h*$sinea,
			   $xc,$yc);
		$pt = array($xc,$yc,$xc+$w*$cosea,$yc-$h*$sinea);
		for( $a=$rea; $a>$rsa; $a -= $step ) {
			$pt[] = $xc + $w*cos($a);
			$pt[] = $yc - $h*sin($a);
		}
		$pt[] = $xc+$w*$cossa;
		$pt[] = $yc-$h*$sinsa;
		$pt[] = $xc;
		$pt[] = $yc;
		}
	}
	else { 
		$p = array($xc,$yc,$xc,$yc+$z,
			   $xc+$w*$cossa,$z+$yc-$h*$sinsa,
			   $xc+$w*$cossa,$yc-$h*$sinsa,
			   $xc,$yc);
		$pt = array($xc,$yc,$xc+$w*$cossa,$yc-$h*$sinsa);
		for( $a=$rsa; $a < $rea; $a += $step ) {
		$pt[] = $xc + $w*cos($a);
		$pt[] = $yc - $h*sin($a);
		}
		$pt[] = $xc+$w*$cosea;
		$pt[] = $yc-$h*$sinea;
		$pt[] = $xc;
		$pt[] = $yc;
	}
		
	$img->PushColor($fillcolor.":".$shadow);
	$img->FilledPolygon($p);
	$img->PopColor();
	$img->PushColor($fillcolor);
	$img->FilledPolygon($pt);
	$img->PopColor();
	}
	function Pie3D($aaoption,$img,$data,$colors,$xc,$yc,$d,$angle,$z,
		   $shadow=0.65,$startangle=0,$edgecolor="",$edgeweight=1) {
	$h = ($angle/90.0)*$d;
	$sum = 0;
	for($i=0; $i<count($data); ++$i ) {
		$sum += $data[$i];
	}
	if( $sum==0 ) return;
	$accsum = 0;
	$a = $startangle;
	$a = $this->NormAngle($a);
	$idx=0;
	$adjexplode=array(); 
	$numcolors = count($colors);
	for($i=0; $i<count($data); ++$i, ++$idx ) {
		$da = $data[$i]/$sum * 360;
		if( empty($this->explode_radius[$i]) )
		$this->explode_radius[$i]=0;
		$expscale=1;
		if( $aaoption == 1 ) 
		$expscale=2;
		$la = $a + $da/2;
		$explode = array( $xc + $this->explode_radius[$i]*cos($la*M_PI/180)*$expscale,
					  $yc - $this->explode_radius[$i]*sin($la*M_PI/180) * ($h/$d) *$expscale );
		$adjexplode[$idx] = $explode;
		$labeldata[$i] = array($la,$explode[0],$explode[1]);
		$originalangles[$i] = array($a,$a+$da);
		$ne = $this->NormAngle($a+$da);
		if( $da <= 180 ) {
		
		
		$split=-1; 
		if( ($da<=90 && ($a <= 90 && $ne > 90)) ||
			(($da <= 180 && $da >90)  && (($a < 90 || $a >= 270) && $ne > 90)) ) {
			$split = 90;
		}
		elseif( ($da<=90 && ($a <= 270 && $ne > 270)) ||
				(($da<=180 && $da>90) && ($a >= 90 && $a < 270 && ($a+$da) > 270 )) ) {
			$split = 270;
		} 
		if( $split > 0 ) { 
			$angles[$idx] = array($a,$split);
			$adjcolors[$idx] = $colors[$i % $numcolors];
			$adjexplode[$idx] = $explode;
			$angles[++$idx] = array($split,$ne);
			$adjcolors[$idx] = $colors[$i % $numcolors];
			$adjexplode[$idx] = $explode;
		}
		else { 
			$angles[$idx] = array($a,$ne);
			$adjcolors[$idx] = $colors[$i  % $numcolors];
			$adjexplode[$idx] = $explode;	
		}
		}
		else { 
		
		
		
		if( $a < 90 ) 
			$split = 90;
		elseif( $a <= 270 )
			$split = 270;
		else 
			$split = 90;
		$angles[$idx] = array($a,$split);
		$adjcolors[$idx] = $colors[$i % $numcolors];
		$adjexplode[$idx] = $explode;
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		if( ($a < 90 && ($a+$da > 270)) ||
			($a > 90 && $a<=270 && ($a+$da>360+90) ) ||
			($a > 270 && $this->NormAngle($a+$da)>270) ) { 
			$angles[++$idx] = array($split,360-$split);
			$adjcolors[$idx] = $colors[$i % $numcolors];
			$adjexplode[$idx] = $explode;
			$angles[++$idx] = array(360-$split,$ne);
			$adjcolors[$idx] = $colors[$i % $numcolors];
			$adjexplode[$idx] = $explode;
		}	
		else {
			
			
			$angles[++$idx] = array($split,$ne);
			$adjcolors[$idx] = $colors[$i % $numcolors];
			$adjexplode[$idx] = $explode;
		}
		}
		$a += $da;
		$a = $this->NormAngle($a);
	}
	$n = count($angles);
	for($i=0; $i<$n; ++$i) {
		list($dbgs,$dbge) = $angles[$i];
	}
	$minval = $angles[0][0];
	$min = 0;
	for( $i=0; $i<$n; ++$i ) {
		if( $angles[$i][0] < $minval ) {
		$minval = $angles[$i][0];
		$min = $i;
		}
	}
	$j = $min;
	$cnt = 0;
	while( $angles[$j][1] <= 90 ) {
		$j++;
		if( $j>=$n) {
		$j=0;
		}
		if( $cnt > $n ) {
		JpGraphError::Raise("Pie3D Internal error (#1). Trying to wrap twice when looking for start index");
		}
		++$cnt;
	}
	$start = $j;
	$cnt = 0;
		
	while( $angles[$j][0] < 270  && $aaoption !== 2 ) {
		list($x,$y) = $adjexplode[$j];
		$this->Pie3DSlice($img,$x,$y,$d,$h,$angles[$j][0],$angles[$j][1],
				  $z,$adjcolors[$j],$shadow);
		$last = array($x,$y,$j);
		$j++;
		if( $j >= $n ) $j=0;
		if( $cnt > $n ) {
		JpGraphError::Raise("Pie3D Internal Error: Z-Sorting algorithm for 3D Pies is not working properly (2). Trying to wrap twice while stroking.");
		}
		++$cnt;
	}
	 
	$slice_left = $n-$cnt;
	$j=$start-1;
	if($j<0) $j=$n-1;
	$cnt = 0;
	while( $cnt < $slice_left  && $aaoption !== 2 ) {
		list($x,$y) = $adjexplode[$j];
		$this->Pie3DSlice($img,$x,$y,$d,$h,$angles[$j][0],$angles[$j][1],
				  $z,$adjcolors[$j],$shadow);
		$j--;
		if( $cnt > $n ) {
		JpGraphError::Raise("Pie3D Internal Error: Z-Sorting algorithm for 3D Pies is not working properly (2). Trying to wrap twice while stroking.");
		}
		if($j<0) $j=$n-1;
		$cnt++;
	}
	if( $aaoption !== 2 )
		$this->Pie3DSlice($img,$last[0],$last[1],$d,$h,$angles[$last[2]][0],
				  $angles[$last[2]][1],$z,$adjcolors[$last[2]],$shadow);
	if( $aaoption !== 1 ) {
		
		$img->SetFont($this->value->ff,$this->value->fs);
		$margin = $img->GetFontHeight()/2;
		for($i=0; $i < count($data); ++$i ) {
		$la = $labeldata[$i][0];
		$x = $labeldata[$i][1] + cos($la*M_PI/180)*($d+$margin);
		$y = $labeldata[$i][2] - sin($la*M_PI/180)*($h+$margin);
		if( $la > 180 && $la < 360 ) $y += $z;
		if( $this->labeltype == 0 )
			if( $sum > 0 )
			$l = 100*$data[$i]/$sum;
			else
			$l = 0;
		else
			$l = $data[$i];
		if( isset($this->labels[$i]) && is_string($this->labels[$i]) )
			$l=sprintf($this->labels[$i],$l);
		$this->StrokeLabels($l,$img,$labeldata[$i][0]*M_PI/180,$x,$y,$z);
		
		$this->AddSliceToCSIM($i,$labeldata[$i][1],$labeldata[$i][2],$h*2,$d*2,$z,
					  $originalangles[$i][0],$originalangles[$i][1]);
		}	
	}
	if( $edgecolor=="" || $aaoption !== 0 ) return;
	$accsum = 0;
	$a = $startangle;
	$a = $this->NormAngle($a);
	$a *= M_PI/180.0;
	$idx=0;
	$img->PushColor($edgecolor);
	$img->SetLineWeight($edgeweight);
	$fulledge = true;
	for($i=0; $i < count($data) && $fulledge; ++$i ) {
		if( empty($this->explode_radius[$i]) )
		$this->explode_radius[$i]=0;
		if( $this->explode_radius[$i] > 0 ) {
		$fulledge = false;
		}
	}
		
	for($i=0; $i < count($data); ++$i, ++$idx ) {
		$da = $data[$i]/$sum * 2*M_PI;
		$this->StrokeFullSliceFrame($img,$xc,$yc,$a,$a+$da,$d,$h,$z,$edgecolor,
					$this->explode_radius[$i],$fulledge);
		$a += $da;
	}
	$img->PopColor();
	}
	function StrokeFullSliceFrame($img,$xc,$yc,$sa,$ea,$w,$h,$z,$edgecolor,$exploderadius,$fulledge) {
	$step = 0.02;
	if( $exploderadius > 0 ) {
		$la = ($sa+$ea)/2;
		$xc += $exploderadius*cos($la);
		$yc -= $exploderadius*sin($la) * ($h/$w) ;
		
	}
	$p = array($xc,$yc,$xc+$w*cos($sa),$yc-$h*sin($sa));
	for($a=$sa; $a < $ea; $a += $step ) {
		$p[] = $xc + $w*cos($a);
		$p[] = $yc - $h*sin($a);
	}
	$p[] = $xc+$w*cos($ea);
	$p[] = $yc-$h*sin($ea);
	$p[] = $xc;
	$p[] = $yc;
	$img->SetColor($edgecolor);
	$img->Polygon($p);
	if( $fulledge && !( $sa > 0 && $sa < M_PI && $ea < M_PI) ) { 
		if($sa < M_PI && $ea > M_PI) 
		$sa = M_PI;
 
		if($sa < 2*M_PI && (($ea >= 2*M_PI) || ($ea > 0 && $ea < $sa ) ) )
		$ea = 2*M_PI;
		if( $sa >= M_PI && $ea <= 2*M_PI ) {
		$p = array($xc + $w*cos($sa),$yc - $h*sin($sa),
			   $xc + $w*cos($sa),$z + $yc - $h*sin($sa));
		
		for($a=$sa+$step; $a < $ea; $a += $step ) {
			$p[] = $xc + $w*cos($a);
			$p[] = $z + $yc - $h*sin($a);
		}
		$p[] = $xc + $w*cos($ea);
		$p[] = $z + $yc - $h*sin($ea);
		$p[] = $xc + $w*cos($ea);
		$p[] = $yc - $h*sin($ea);
		$img->SetColor($edgecolor);
		$img->Polygon($p);	    
		}
	}
	}
	function Stroke($img,$aaoption=0) {
   	if( $this->setslicecolors==null ) {
		$colors = array_keys($img->rgb->rgb_table);
		sort($colors);	
		$idx_a=$this->themearr[$this->theme];	
		$ca = array();
		$n = count($idx_a);
		for($i=0; $i < $n; ++$i)
		$ca[$i] = $colors[$idx_a[$i]];
	}
   	else {
		$ca = $this->setslicecolors;
	}
	if( $this->posx <= 1 && $this->posx > 0 )
		$xc = round($this->posx*$img->width);
	else
		$xc = $this->posx ;
	if( $this->posy <= 1 && $this->posy > 0 )
		$yc = round($this->posy*$img->height);
	else
		$yc = $this->posy ;
   			
	if( $this->radius <= 1 ) {
		$width = floor($this->radius*min($img->width,$img->height));
		
		
		
		$width = min($width,min($xc*0.9,($yc*90/$this->angle-$width/4)*0.9));
	}
	else {
		$width = $this->radius * ($aaoption === 1 ? 2 : 1 ) ;
	}
	if( $width < 1 ) { 
		JpGraphError::Raise("Width for 3D Pie is 0. Specify a size > 0");
		exit();
	}
	if( $this->iThickness ) {
	  $thick = $this->iThickness;
	  $thick *= ($aaoption === 1 ? 2 : 1 );
	}
	else
	  $thick = $width/12;
	$a = $this->angle;
	if( $a <= 30 ) $thick *= 1.6;
	elseif( $a <= 40 ) $thick *= 1.4;
	elseif( $a <= 50 ) $thick *= 1.2;
	elseif( $a <= 60 ) $thick *= 1.0;
	elseif( $a <= 70 ) $thick *= 0.8;
	elseif( $a <= 80 ) $thick *= 0.7;
	else $thick *= 0.6;
	$thick = floor($thick);
	if( $this->explode_all )
		for($i=0;$i<count($this->data);++$i)
		$this->explode_radius[$i]=$this->explode_r;
	$this->Pie3D($aaoption,$img,$this->data, $ca, $xc, $yc, $width, $this->angle, 
				 $thick, 0.65, $this->startangle, $this->edgecolor, $this->edgeweight);
	if( $aaoption != 1 ) {
		$this->title->Pos($xc,$yc-$this->title->GetFontHeight($img)-$width/2-$this->title->margin,			      "center","bottom");
		$this->title->Stroke($img);
	}
	}
	function StrokeLabels($label,$img,$a,$xp,$yp,$z) {
	$this->value->halign="left";
	$this->value->valign="top";
	$this->value->margin=0;
	$img->SetFont($this->value->ff,$this->value->fs,$this->value->fsize);
	$h=$img->GetTextHeight($label);
	if( is_numeric($label) ) {
		if( $label > 0 )
		$w=$img->GetTextWidth(sprintf($this->value->format,$label));
		else
		$w=$img->GetTextWidth(sprintf($this->value->negormat,$label));
	}
	else
		$w=$img->GetTextWidth($label);
	while( $a > 2*M_PI ) $a -= 2*M_PI;
	if( $a>=7*M_PI/4 || $a <= M_PI/4 ) $dx=0;
	if( $a>=M_PI/4 && $a <= 3*M_PI/4 ) $dx=($a-M_PI/4)*2/M_PI; 
	if( $a>=3*M_PI/4 && $a <= 5*M_PI/4 ) $dx=1;
	if( $a>=5*M_PI/4 && $a <= 7*M_PI/4 ) $dx=(1-($a-M_PI*5/4)*2/M_PI);
		
	if( $a>=7*M_PI/4 ) $dy=(($a-M_PI)-3*M_PI/4)*2/M_PI;
	if( $a<=M_PI/4 ) $dy=(1-$a*2/M_PI);
	if( $a>=M_PI/4 && $a <= 3*M_PI/4 ) $dy=1;
	if( $a>=3*M_PI/4 && $a <= 5*M_PI/4 ) $dy=(1-($a-3*M_PI/4)*2/M_PI);
	if( $a>=5*M_PI/4 && $a <= 7*M_PI/4 ) $dy=0;
	$x = round($xp-$dx*$w);
	$y = round($yp-$dy*$h);
	/*
	    
	$img->SetColor('red');
	$img->Line($xp-10,$yp,$xp+10,$yp);
	$img->Line($xp,$yp-10,$xp,$yp+10);
	*/
	$this->value->Stroke($img,$label,$x,$y);
	}	
} 
/* EOF */