<?php
/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003, Secure.cc, Inc.

*/

error_reporting(E_ERROR);
set_error_handler("webdav_error_handler");

require('../config.php');
require('contents/eshox_os/admin_main.php');

define('RFC0822_DATE', 'D, d M Y H:i:s T');

define('NULL_BIT', "0000000000");
define('BITS', 11);

shop_db_connect();
shop_load_configuration();

$GLOBALS['webdav'] = new webdav();

return true;

// Internal Functions Start Here

function webdav_error_handler($errno, $errstr, $errfile, $errline, $errctx) {
	if ($errno < 9) return;
	if ($GLOBALS['webdav']->logging) {
		if (!$GLOBALS['webdav']->logfile) $GLOBALS['webdav']->logfile = fopen('contents/tmp/webdav.log','a');
		fwrite($GLOBALS['webdav']->logfile, MAC_RETURN . 'ERROR ' . TAB . date(RFC0822_DATE) . TAB . 
											$GLOBALS['webdav']->username . '(' . $GLOBALS['webdav']->perms . ')' . TAB . 
											$errstr . ' (#' . $errno . ' in ' . basename($errfile) . ', line ' . $errline . ').');
		fclose($GLOBALS['webdav']->logfile);
	}
	die;
}

class webdav {
	var $status = array(200 => "HTTP/1.1 200 Ok",
						201 => "HTTP/1.1 201 Created",	
						204 => "HTTP/1.1 204 No Content", 
						207 => "HTTP/1.1 207 Multi-Status", 
						401 => "HTTP/1.1 401 Unauthorized", 
						403 => "HTTP/1.1 403 Forbidden", 
						404 => "HTTP/1.1 404 Not Found", 
						405 => "HTTP/1.1 405 Method Not Allowed", 
						409 => "HTTP/1.1 409 Conflict", 
						412 => "HTTP/1.1 412 Precondition Failed", 
						424 => "HTTP/1.1 424 Failed Dependency", 
						502 => "HTTP/1.1 502 Bad Gateway", 
						507 => "HTTP/1.1 507 Unsifficient Storage");

	var $logging = false;

	function webdav () {
		if ($this->logging) $this->logfile = fopen('contents/tmp/webdav.log','a');

		$this->request = array_merge($_SERVER, $_GET, $_POST);
		$this->username = $this->request['PHP_AUTH_USER'];
		$this->password = crypt($this->request['PHP_AUTH_PW'], 'fgshdfgshasdg');
		$this->path = $this->request['PATH_INFO'];

		$user_query = shop_db_fetch_array(shop_db_query("select permissions from " . DB_PREFIX . "admin_users where username = '" . $this->username . "' and password = '" . $this->password . "'"));
		$this->perms = $user_query['permissions'];
		$this->user = preg_split("//",(substr(NULL_BIT . base_convert($this->perms,10,2),-10)));
		
		if ($this->logging) fwrite($this->logfile, MAC_RETURN . $this->request["REQUEST_METHOD"] . TAB . date(RFC0822_DATE) . TAB . $this->username . '(' . $this->perms . ')');

		$languages_query = shop_db_fetch_array(shop_db_query('select languages_id from ' . DB_PREFIX . 'languages where code = "' . DEFAULT_LANGUAGE . '"'));
		$this->languages_id = $languages_query['languages_id'];

		if (!$this->user || $this->user[BITS-6] != '1') {
			header($this->status[401]);
			header('WWW-Authenticate: Basic realm="' . HOST . '"');
			return;
		}

		switch ($this->request["REQUEST_METHOD"]) {
			case "PROPFIND":
				$this->propfind();
				break;
			case "GET":
				$this->get();
				break;
			case "PUT":
				$this->put();
				break;
			case "MOVE":
				$this->mv();
				break;
			case "MKCOL":
				$this->mkcol();
				break;
			case "DELETE":
				$this->delete();
				break;
			case "OPTIONS":
				$this->options();
				break;
			default:
				header($this->status[204]);
				break;
		}
		if ($this->logging) fclose($this->logfile);
	}

	function propfind () {
		$files = array();
		$directory = DIR_FS_CATALOG . $this->path;

		if ($this->user[BITS-5] == '1' && substr($this->path,0,25) == '/products and categories/') {
			$path_array = explode('/', $this->path);
			if (sizeof($path_array) > 2) {
				$parent = shop_db_fetch_array(shop_db_query("select c.categories_id from " . DB_PREFIX . "categories c, " . DB_PREFIX . "categories_description cd where c.categories_id = cd.categories_id and cd.language_id = '" . $this->languages_id . "' and c.categories_code = '" . $path_array[sizeof($path_array)-2] . "'"));
				$model = '';
			} else {
				$model = "p.products_model = '" . substr($path_array[sizeof($path_array)-1],0,-5) . "' and";
				$parent = array("categories_id" => 0);
			}
	 		$products_query = shop_db_query("select p.*, pd.* from " . DB_PREFIX . "products p, " . DB_PREFIX . "products_description pd, " . DB_PREFIX . "products_to_categories p2c where p2c.products_id = p.products_id and pd.products_id = p.products_id and $model pd.language_id = '" . $this->languages_id . "' and p2c.categories_id = '" . $parent['categories_id'] . "' order by p2c.sort_order");
			while ($products = shop_db_fetch_array($products_query)) {
				$files[] = array('href' => '/' . str_replace(" ", "%20", $products['products_model'] . '.html'), 
								 'contenttype' => 'text/html',
								 'isdirectory' => false);
			}
			$categories_query = shop_db_query("select c.*, cd.* from " . DB_PREFIX . "categories c, " . DB_PREFIX . "categories_description cd where c.categories_id = cd.categories_id and cd.language_id = '" . $this->languages_id . "' and c.parent_id = '" . $parent['categories_id'] . "' order by c.sort_order");
			while ($categories = shop_db_fetch_array($categories_query)) {
				$files[] = array('href' => str_replace(" ", "%20", $this->path . '/' . $categories['categories_code'] . '/'), 
								 'contenttype' => 'httpd/unix-directory', 
								 'isdirectory' => true);
			}
			$files[] = array('href'=> '/' , 'isdirectory' => true);
		} elseif (is_file($directory)) {
			$files = array(array('href' => $this->path, 
								 'created' => date(RFC0822_DATE, filectime($this->path)), 
								 'modified' => date(RFC0822_DATE, filemtime($this->path)),
								 'isdirectory' => false),
						   array('href'=> '/' , 'isdirectory' => true));
		} elseif ($this->path == '/admin/') {
			$files[] = array('href'=> '/templates/', 'isdirectory' => true);
		} elseif ($dir = @dir($directory)) {
			if ($this->user[BITS-5] == '1' && $this->path == '/') {
				$files[] = array('href'=> '/products and categories/', 'isdirectory' => true, 'created' => '', 'modified' => '');
			}
			while ($file = $dir->read()) {
				if ($file == 'contents' || $file == 'fonts' || $file == 'setup' || substr($file,0,1) == '.' || substr($file,-4,4) == '.php') continue;
				$path = $directory . $file;
				$info = array('modified' => date(RFC0822_DATE, filemtime($path)));
				if (is_dir($path)) {
					$info['href'] = '/' . basename($file);
					$info['contentlength'] = 0;
					$info['contenttype'] = "httpd/unix-directory";
					$info['isdirectory'] = true;
				} else {
					$info['href'] = '/' . basename($file);
					$info['contentlength'] = filesize($path);
					if ($size = getimagesize($path)) {
						$info['contenttype'] = $size['mime'];
					} else {
						$info['contenttype'] = 'text/html';
					}
					$info['isdirectory'] = false;
				}
				$files[] = $info;
			}
		} else {
			header($this->status[404]);
			return;
		}
		
		header($this->status[207]);
		header('Connection: close');
		header('Content-Type: text/xml charset="utf-8"');
		$result = '<' . '?xml version="1.0" encoding="utf-8"?' . '>' . UNIX_RETURN;
		$result .= '<D:multistatus xmlns:D="DAV:">' . UNIX_RETURN;
		foreach($files as $file) {
			if ($this->logging) fwrite($this->logfile, TAB . str_replace(' ','%20',$file['href']));
			$result .= '<D:response xmlns:lp0="DAV:" xmlns:lp1="http://apache.org/dav/props/" xmlns:lp2="http://www.apple.com/webdav_fs/props/" xmlns:i0="DAV:" xmlns:i1="http://apache.org/dav/props/">' . UNIX_RETURN;
			$result .= '<D:href>' . $file['href'] . '</D:href>' . UNIX_RETURN;
			$result .= '<D:propstat>' . UNIX_RETURN;
			$result .= '<D:prop>' . UNIX_RETURN;
			if ($file['modified']) {
				$result .= '<lp0:getlastmodified>' . $file['modified'] . '</lp0:getlastmodified>' . UNIX_RETURN;
				$result .= '<D:getlastmodified>' . $file['modified'] . '</D:getlastmodified>' . UNIX_RETURN;
			}
			if ($file['isdirectory']) {
				$result .= "<D:resourcetype><D:collection/></D:resourcetype>" . UNIX_RETURN;
				$result .= '<D:getcontenttype>httpd/unix-directory</D:getcontenttype>' . UNIX_RETURN;
				$result .= '<i0:getcontentlength/>' . UNIX_RETURN;
			} else {
				$result .= '<D:supportedlock/>' . UNIX_RETURN;
				$result .= '<D:getcontenttype>' . $file['contenttype'] . '</D:getcontenttype>' . UNIX_RETURN;
				$result .= '<D:getcontentlength>' . $file['contentlength'] . '</D:getcontentlength>' . UNIX_RETURN;
			}
			$result .= '<i0:executable/>' . UNIX_RETURN;
			$result .= '<D:lockdiscovery/>' . UNIX_RETURN;
			$result .= '</D:prop>' . UNIX_RETURN;
			$result .= '<D:status>HTTP/1.1 200 Ok</D:status>' . UNIX_RETURN;
			$result .= '</D:propstat>' . UNIX_RETURN;
			$result .= '</D:response>' . UNIX_RETURN;
		}
		$result .= '</D:multistatus>' . UNIX_RETURN;
		echo $result;
	}

	function get () {
		header($this->status[200]);
		header('Content-Type: application/octet-stream');
		if ($this->user[BITS-5] == '1' && substr($this->path,0,25) == '/products and categories/') {
			$model = substr(basename($this->path),0,-5);
			$description = shop_db_fetch_array(shop_db_query("select pd . *, p . * from " . DB_PREFIX . "products_description pd, " . DB_PREFIX . "products p where pd.products_id = p.products_id and pd.language_id = '" . $this->languages_id . "' and p.products_model = '$model'"));
			header('Content-Length: ' . strlen($description['products_description']));
			echo $description['products_description'];
		} else {
			$path = DIR_FS_CATALOG . $this->path;
			header('Content-Length: ' . filesize($path));
			readfile($path);
			die;
		}
	}

	function put () {
		if ($this->user[BITS-5] == '1' && substr($this->path,0,25) == '/products and categories/') {
			header($this->status[200]);
			$description = '';
			$upload = fopen("php://input","r");
			while ($data = fread($upload,1024)) $description .= $data;
			fclose($upload);
			shop_db_query("update " . DB_PREFIX . "products_description pd, " . DB_PREFIX . "products p set products_description = '" . ($description) . "' where pd.products_id = p.products_id and pd.language_id = '" . $this->languages_id . "' and p.products_model = '" . substr(basename($this->path), 0, -5) . "'");
		} else {
			if (!(substr($this->path,-3) == 'php')) {
				header($this->status[200]);
				$upload = fopen("php://input","r");
				$file = fopen(DIR_FS_CATALOG . $this->path, 'w');
				while ($data = fread($upload,4096)) fwrite($file, $data);
				fclose($upload); fclose($file);
			} else {
				header($this->status[404]);
				die;
			}
		}
		header('Content-Type: text/html');
		echo '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<HTML><HEAD>
<TITLE>201 Created</TITLE>
</HEAD><BODY>
<H1>Created</H1>
Resource ' . $this->path . ' has been created.</BODY></HTML>
';
		die;
	}

	function mv () {
		if (!(substr($this->request['HTTP_DESTINATION'],-4,4) == '.php')) {
			header($this->status[201]);
			$destination = explode('admin/dreamweaver.php/', str_replace(DIR_WS_ADMIN, '', urldecode($this->request['HTTP_DESTINATION'])));
			if ($this->logging) fwrite($this->logfile, TAB . $this->path . TAB . 'TO' . TAB . '/' . $destination[1]);
			rename(DIR_FS_CATALOG . $this->path, DIR_FS_CATALOG . $destination[1]);
		} else {
			header($this->status[404]);
		}
	}

	function mkcol () {
		header($this->status[201]);
		mkdir(DIR_FS_CATALOG . $this->path, 777);
	}

	function delete () {
		header($this->status[204]);
		$path = DIR_FS_CATALOG . $this->path;
		if (is_dir($path)) {
			rmdir($path);
		} else {
			unlink($path);
		}
	}

	function options () {
		header($this->status[200]);
		header("MS-Author-Via: DAV");
	 	header("Allow: PROPFIND, GET, PUT, MOVE, MKCOL, DELETE, OPTIONS");
		header("DAV: 1");
	}
}
