<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/
  
  class linkpoint {
	var $code, $title, $description, $enabled;

	function linkpoint() {
	  $this->code = 'linkpoint';
	  $this->title = 'Card Service LinkPoint';
	  $this->shop_title = MODULE_PAYMENT_CC_TEXT_TITLE;
	  $this->description = '';
	  $this->signup = 'http://www.linkpoint.com/';
	  $this->enabled = defined('MODULE_PAYMENT_LINKPOINT_STATUS');
	  $this->recommend_level = 5;
	  $this->version = "2.0";
	}

	function javascript_validation() {
	  return shop_draw_cc_javascript_validation($this->code);
	}

	function selection() {
	  return shop_draw_cc_input();
	}

	function pre_confirmation_check() {
	  
	  if ($_POST['payment_selected'] == $this->code) shop_validate_cc($_POST['cc_owner'],$_POST['cc_number'], $_POST['cc_expires_month'], $_POST['cc_expires_year'], $_POST['cc_code']);
	}

	function confirmation() {
	  return false;
	}

	function process_button() {
	  $process_button_string = shop_draw_hidden_field('cc_owner', $_POST['cc_owner']) . 
	                           shop_draw_hidden_field('cc_number', $_POST['cc_number']) . 
	                           shop_draw_hidden_field('cc_code', $_POST['cc_code']) . UNIX_RETURN .
	                           shop_draw_hidden_field('cc_expires_month', $_POST['cc_expires_month']) . UNIX_RETURN .
	                           shop_draw_hidden_field('cc_expires_year', $_POST['cc_expires_year']) . UNIX_RETURN;

	  return $process_button_string;
	}

	function before_process() {
	  global $order;
	  
	  //$linkpoint_url = 'https://secure.linkpt.net:1129/LSGSXML';
	  $linkpoint_url = 'https://staging.linkpt.net:1129/LSGSXML';
	  print_r($order->customer);
	  $keys = array('orderoptions' => 'orderoptions',
	  				  'result' => 'LIVE',
	  				  'ordertype' => 'SALE',
	  				'/orderoptions' => '/orderoptions',
	  				'transactiondetails' => 'transactiondetails',
	  				  'oid' => $order->info['orders_id'],
	  				'/transactiondetails' => '/transactiondetails',
	  				'merchantinfo' => 'merchantinfo',
	  				  'configfile' => MODULE_PAYMENT_LINKPOINT_STORE_NUMBER,
	  				'/merchantinfo' => '/merchantinfo',
	  				'payment' => 'payment',
					  'chargetotal' => round($order->info['total'] * 100),
	  				'/payment' => '/payment',
					'billing' => 'billing',
					  'name' => $_POST['cc_owner'],
					  'address1' => $order->customer['street_address'],
					  'address2' => $order->customer['street_address2'],
					  'city' => $order->customer['city'],
					  'state' => $order->customer['state'],
					  'zip' => $order->customer['postcode'],
					  'country' => $order->customer['country'],
					  'phone' => $order->customer['telephone'],
					  'email' => $order->customer['email_address'],
					'/billing' => '/billing',
					'creditcard' => 'creditcard',
					  'cardnumber' => $_POST['cc_owner'],
					  'cardexpmonth' => $_POST['cc_expires_month'],
					  'cardexpyear' => $_POST['cc_expires_year'],
					  'cvmvalue' => $_POST['cc_code'],
					'/creditcard' => '/creditcard');

	  $xml = UNIX_RETURN . '<order>' . UNIX_RETURN;
	  foreach ($keys as $key => $value) {
	    if ($key != $value) {
	      $xml .= "  <$key>$value</$key>" . UNIX_RETURN;
	    } else {
	      $xml .= "<$value>" . UNIX_RETURN;
	    }
	  }
	  $xml .= '</order>';
	  
	  $ch = curl_init ($linkpoint_url);
	  curl_setopt ($ch, CURLOPT_POST, 1);
	  curl_setopt ($ch, CURLOPT_POSTFIELDS, $xml);
	  curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1); 
	  curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0); 
	  $request = str_replace("><",">\r<",curl_exec($ch));
	  preg_match_all('/<([^>]+)>([^<]+)/', $request, $response);
	  
	  curl_close($ch);
	  
	  $result = array();
	  for ($x=0; $x<sizeof($response[1]); $x++) {
	    if (strlen($response[2][$x]) > 2) $result[$response[1][$x]] = $response[2][$x];
	  }

	  if ($result['r_approved'] != 'APPROVED') {
		shop_redirect(shop_href_link('checkout_payment.php', 'error_message=' . urlencode(MODULE_PAYMENT_CC_TEXT_ERROR . ' ' . $result['r_error']), 'SSL'));
	  }
	}

	function after_process() {
	  return false;
	}

	function check() {
	  return defined('MODULE_PAYMENT_LINKPOINT_STATUS');
	}

	function install() {
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_PAYMENT_LINKPOINT_STATUS', 'true')");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('LinkPoint Store Number', 'MODULE_PAYMENT_LINKPOINT_STORE_NUMBER', '1234567', 'Your LinkPoint store number', '6', '1', now())");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key in ('" . implode("','", $this->keys()) . "')");
	}

	function keys() {
	  return array('MODULE_PAYMENT_LINKPOINT_STATUS', 'MODULE_PAYMENT_LINKPOINT_STORE_NUMBER');
	}
  }
