<?php

/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2004, Secure.cc, Inc.

*/

class paypal_ipn {
	var $code, $title, $description, $enabled;

	function paypal_ipn() {
		$this->code = 'paypal_ipn';
		$this->title = 'PayPal IPN';
		$this->shop_title = 'PayPal';
		$this->description = '';
		$this->signup = 'http://www.paypal.com/';
		$this->enabled = defined('MODULE_PAYMENT_PAYPALIPN_STATUS');
		$this->recommend_level = 5;
		$this->version = "3.0";
	}

	function javascript_validation() {
		return false;
	}

	function selection() {
		return false;
	}

	function pre_confirmation_check() {
		return false;
	}

	function confirmation() {
		global $checkout_form_action;
		global $checkout_form_onsubmit;
		$checkout_form_action = 'https://www.paypal.com/cgi-bin/webscr';
		$checkout_form_onsubmit = 'return paypalAlert();';
	}

	function process_button() {
		global $order;
		
		if (MODULE_PAYMENT_PAYPALIPN_ID == 'use_affiliate') {
			$paypal_address = STORE_OWNER_EMAIL_ADDRESS;
		} else {
			$paypal_address = MODULE_PAYMENT_PAYPALIPN_ID;
		}
				
		$_SESSION['paypal_salt'] = crypt(rand(1000,9999));
		
		$tmp = @preg_replace('/[^0-9]/','', $order->customer['telephone']);
		$paypal_phone = array(@substr($tmp,0,3),@substr($tmp,3,3),@substr($tmp,6));
		$process_button_string = 
			// required variables
			shop_draw_hidden_field('cmd', '_ext-enter') . 
			shop_draw_hidden_field('redirect_cmd', '_xclick') . 
			shop_draw_hidden_field('business', $paypal_address) . 
			shop_draw_hidden_field('item_name', STORE_NAME) .
			shop_draw_hidden_field('currency_code', $_SESSION['currency']) .
			shop_draw_hidden_field('amount', $GLOBALS['currencies']->format($order->info['total'], true, $order->info['currency'], $order->info['currency_value'])) .
			// available variables
			shop_draw_hidden_field('no_shipping', '1') .
			shop_draw_hidden_field('no_note', '1') .
			shop_draw_hidden_field('on0', session_name()) .
			shop_draw_hidden_field('os0', session_id()) .
			shop_draw_hidden_field('custom', crypt(number_format($order->info['total'],2), $_SESSION['paypal_salt'])) .
			shop_draw_hidden_field('notify_url', shop_href_link('checkout_process.php', session_name() . '=' . session_id(), 'SSL')) .
			shop_draw_hidden_field('return', shop_href_link('checkout_success.php', '', 'SSL')) .
			shop_draw_hidden_field('cancel_return', shop_href_link('checkout_payment.php', '', 'SSL')) .
			// extended variables
			shop_draw_hidden_field('email', $order->customer['email_address']) . 
			shop_draw_hidden_field('first_name', $order->customer['firstname']) . 
			shop_draw_hidden_field('last_name', $order->customer['lastname']) . 
			shop_draw_hidden_field('address1', $order->customer['street_address']) . 
			shop_draw_hidden_field('address2', $order->customer['street_address_2']) . 
			shop_draw_hidden_field('city', $order->customer['city']) . 
			shop_draw_hidden_field('state', shop_get_zone_code($_SESSION['customer_country_id'], $_SESSION['customer_zone_id'])) . 
			shop_draw_hidden_field('zip', $order->customer['postcode']) . 
			shop_draw_hidden_field('night_phone_a', $paypal_phone[0]) . 
			shop_draw_hidden_field('night_phone_b', $paypal_phone[1]) . 
			shop_draw_hidden_field('night_phone_c', $paypal_phone[2]) . 
			shop_draw_hidden_field('day_phone_a', $paypal_phone[0]) . 
			shop_draw_hidden_field('day_phone_b', $paypal_phone[1]) . 
			shop_draw_hidden_field('day_phone_c', $paypal_phone[2]) .
			shop_draw_hidden_field('bn', 'eShox3');
			// add alert for paypal return to merchant
			$process_button_string .= '<script language="javascript"><!--
function paypalAlert() {
	alert("IMPORTANT: After completing the payment of your order on the PayPal site let it forward you back to the Script Software site. Otherwise the order is not finalized in our database and your registration won\'t automatically be sent. Thanks");
}
//--></script>';
		return $process_button_string;
	}

	function before_process() {
		global $order;

		if (MODULE_PAYMENT_PAYPALIPN_ID == 'use_affiliate') {
			$paypal_address = STORE_OWNER_EMAIL_ADDRESS;
		} else {
			$paypal_address = MODULE_PAYMENT_PAYPALIPN_ID;
		}

		$req = 'cmd=_notify-validate';
		foreach ($_POST as $key => $value) $req .= "&$key=" . urlencode(stripslashes($value));
		$header .= "POST /cgi-bin/webscr HTTP/1.0\r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";

		if ($fp = fsockopen('www.paypal.com', 80)) {
			fputs($fp, $header . $req);
			while (!feof($fp)) {
				$res = fgets($fp, 1024);
				if (strcmp($res, "VERIFIED") == 0) $verified = true;
			}

			if ($verified && $_POST['business'] == $paypal_address) {
				if (crypt(number_format($_POST['mc_gross'],2), $_SESSION['paypal_salt']) == $_POST['custom']) {
					unset($_SESSION['paypal_salt']);
					if ($_POST['txn_id']) {
						$order->info['cc_approval'] = $_POST['txn_id'];
						$order->info['comments'] .= "Paypal Transaction #" . $_POST['txn_id'];
					}
					return true;
				}
			}
		}
		header('HTTP/1.1 404 Not Found');
		trigger_error("BAD TRANSACTION" . $_POST['payment_status'], FATAL);
	}

	function after_process() {
		header('HTTP/1.1 200 OK');
		die(TEXT_SUCCESS);
	}

	function check() {
		return defined('MODULE_PAYMENT_PAYPALIPN_STATUS');
	}

	function install() {
		shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_PAYMENT_PAYPAL%'");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_PAYMENT_PAYPALIPN_STATUS', 'true')");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id) values ('PayPal Email Account', 'MODULE_PAYMENT_PAYPALIPN_ID', 'use_affiliate', 'The PayPal business account e-mail address to use for transactions. Set to &quot;use_affiliate&quot; to use the store affiliate Email address.', '6')");
	}

	function remove() {
		shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_PAYMENT_PAYPAL%'");
	}

	function keys() {
		return array('MODULE_PAYMENT_PAYPALIPN_STATUS','MODULE_PAYMENT_PAYPALIPN_ID');
	}
}
