<?php

/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003-04, Secure.cc, Inc.

*/

class dhl_usa {
	var $code, $title, $description, $icon, $enabled, $recommend_level, $version, $quote;

	function dhl_usa() {
		$this->code = 'dhl_usa';
		$this->title = 'DHL-USA';
		$this->description = 'DHL-USA Shipping Options:';
		$this->icon = 'images/shipping/shipping_dhl.gif';
		$this->enabled = defined('MODULE_SHIPPING_DHL_USA_STATUS');
		$this->recommend_level = 5;
		$this->version = "2.01";
		$this->quote = array();
	}

	function quote() {
		global $shipping_weight, $shipping_num_boxes, $address_values;
		if (STORE_COUNTRY_CODE != 'US' || $address_values['country_code'] != 'US') return false;
		
		$dhl_usa_product_codes_array = array('E' => array('Service' => '&nbsp; DHL Next Day 12:00 pm', 'Method' => 'DHL EXP', 'Status' => MODULE_SHIPPING_DHL_USA_OVERNIGHT), 
											 'N' => array('Service' => '&nbsp; DHL Next Day 3:00 pm', 'Method' => 'DHL NAS', 'Status' => MODULE_SHIPPING_DHL_USA_NEXT_AFTERNOON),
											 'S' => array('Service' => '&nbsp; DHL 2nd Day', 'Method' => 'DHL SDS', 'Status' => MODULE_SHIPPING_DHL_USA_SECOND_DAY),
											 'G' => array('Service' => '&nbsp; DHL Ground', 'Method' => 'DHL GDS', 'Status' => MODULE_SHIPPING_DHL_USA_GROUND));
		$dhl_account = preg_replace("/([0]+)(.*)/","\$2",MODULE_SHIPPING_DHL_USA_ACCOUNT_NUMBER);

		if (MODULE_SHIPPING_DHL_USA_KEY == 'unset' OR MODULE_SHIPPING_DHL_USA_KEY == '') {
		  $request = array("tt" => STORE_NAME,
						   "pc" => STORE_ORIGIN_ZIP,
						   "a" => $dhl_account);

		  $dhl_usa_key = trim(http_request("http://tools.secure.cc/dhl-register.php", $request));
		  if ($dhl_usa_key) {
		    shop_db_query("update configuration set configuration_value = '$dhl_usa_key' where configuration_key = 'MODULE_SHIPPING_DHL_USA_KEY'");
		  }
		} else {
		  $dhl_usa_key = MODULE_SHIPPING_DHL_USA_KEY;
		}
		
		$request = array("w" => $shipping_weight,
						 "ds" => $address_values['st'],
						 "dz" => $address_values['postcode'],
						 "dc" => $address_values['country_code'],
						 "k" => $dhl_usa_key,
						 "a" => $dhl_account);

		$result = trim(http_request("http://tools.secure.cc/dhl.php", $request));
		$result_array = split("[;,]", $result);
		$shipping_dhl_usa_cost = 9999;
		$rates = array();
		for ($x=0; $x<sizeof($result_array); $x+=2) {
			$code = $result_array[$x];
			$total = $result_array[$x+1];
			if ($total > 0 && $dhl_usa_product_codes_array[$code]['Status'] == 'true') {
				$total = $total + ($total * (SHIPPING_MARK/100));
				$total = (SHIPPING_HANDLING_TOTAL + $total) * $shipping_num_boxes;
				if ($total < $shipping_dhl_usa_cost) $shipping_dhl_usa_cost = $total;
				$this->quote[] = array('Method' => $dhl_usa_product_codes_array[$code]['Method'], 'Service' => $dhl_usa_product_codes_array[$code]['Service'], 'TotalCharges' => $total);
			}
		}

		return $shipping_dhl_usa_cost;
	}

	function check() {
	  return defined('MODULE_SHIPPING_DHL_USA_STATUS');
	}

	function install() {
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_SHIPPING_DHL_USA_STATUS', 'true')");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('DHL-USA Account Number', 'MODULE_SHIPPING_DHL_USA_ACCOUNT_NUMBER', '123456789', '6', '1', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('DHL-USA Shipping Key - Automatically generated if blank or unset.', 'MODULE_SHIPPING_DHL_USA_KEY', 'unset', '6', '2', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_group_id, sort_order, use_function, set_function, date_added) values ('DHL-USA Ground', 'MODULE_SHIPPING_DHL_USA_GROUND', 'true', '6', '3', 'shop_cfg_checkbox_display(', 'shop_cfg_checkbox(', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_group_id, sort_order, use_function, set_function, date_added) values ('DHL-USA Next Day 12:00 pm', 'MODULE_SHIPPING_DHL_USA_OVERNIGHT', 'true', '6', '4', 'shop_cfg_checkbox_display(', 'shop_cfg_checkbox(', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_group_id, sort_order, use_function, set_function, date_added) values ('DHL-USA Next Day 3:00 pm', 'MODULE_SHIPPING_DHL_USA_NEXT_AFTERNOON', 'true', '6', '5', 'shop_cfg_checkbox_display(', 'shop_cfg_checkbox(', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_group_id, sort_order, use_function, set_function, date_added) values ('DHL-USA 2nd Day', 'MODULE_SHIPPING_DHL_USA_SECOND_DAY', 'true', '6', '6', 'shop_cfg_checkbox_display(', 'shop_cfg_checkbox(', now())");
	}

	function remove() {
		shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_SHIPPING_DHL_USA_%'");
	}

	function keys() {
		$keys = array('MODULE_SHIPPING_DHL_USA_STATUS', 'MODULE_SHIPPING_DHL_USA_KEY', 'MODULE_SHIPPING_DHL_USA_ACCOUNT_NUMBER', 'MODULE_SHIPPING_DHL_USA_GROUND', 'MODULE_SHIPPING_DHL_USA_OVERNIGHT', 'MODULE_SHIPPING_DHL_USA_SECOND_DAY', 'MODULE_SHIPPING_DHL_USA_NEXT_AFTERNOON');

		return $keys;
	}
}